import {ValueIsSet} from "../index";

class RouteHelper {
    constructor(history) {
        this.history = history;
    }

    goBackToLastOccurrence(pathname) {
        let {history} = this;

        let occurrenceIndex = null;
        for (let index = history.entries.length - 1, n = 0; index >= n; index--) {
            if(history.entries[index].pathname === pathname) {
                occurrenceIndex = index;
                break;
            }
        }

        if (!ValueIsSet(occurrenceIndex)) {
            return false;
        }

        history.go((history.length - (occurrenceIndex + 1)) * -1);
        history.entries = history.entries.slice(0, occurrenceIndex + 1);
        history.length = occurrenceIndex + 1;
        return true;
    }

    getPreviousPagePathname() {
        let {history} = this;

        let previousIndex = history.entries.length - 2;
        return history.entries[previousIndex].pathname;
    }

    goBack() {
        this.history.goBack();
    }

    push(linkTo, linkToState) {
        this.history.push(linkTo, linkToState);
    }


}

export default RouteHelper;